"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = reducer;
exports.addTyping = addTyping;
exports.deleteTyping = deleteTyping;
exports.setTyping = setTyping;
exports.initialState = exports.DELETE_TYPING_INDICATOR = exports.ADD_TYPING_INDICATOR = void 0;

var _immutable = require("immutable");

var ADD_TYPING_INDICATOR = 'indicators/ADD_TYPING_INDICATOR';
exports.ADD_TYPING_INDICATOR = ADD_TYPING_INDICATOR;
var DELETE_TYPING_INDICATOR = 'indicators/DELETE_TYPING_INDICATOR';
exports.DELETE_TYPING_INDICATOR = DELETE_TYPING_INDICATOR;
var initialState = (0, _immutable.fromJS)({
  typing: {}
});
exports.initialState = initialState;

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case ADD_TYPING_INDICATOR:
      return state.setIn(['typing', action.payload.userId], true);

    case DELETE_TYPING_INDICATOR:
      return state.deleteIn(['typing', action.payload.userId]);

    default:
      return state;
  }
}

function addTyping(userId) {
  return {
    type: ADD_TYPING_INDICATOR,
    payload: {
      userId: userId
    }
  };
}

function deleteTyping(userId) {
  return {
    type: DELETE_TYPING_INDICATOR,
    payload: {
      userId: userId
    }
  };
}

function setTyping(userId, value) {
  if (value) {
    return addTyping(userId);
  }

  return deleteTyping(userId);
}