import configureMockStore from 'redux-mock-store';
import thunk from 'redux-thunk';

import * as actions from '.';

const {initialState} = actions;
const middlewares = [thunk];
const mockStore = configureMockStore(middlewares);

let store;

describe('redux-module-indicators actions ', () => {
  beforeEach(() => {
    store = mockStore(initialState);
  });

  it('has exported actions', () => {
    expect(actions.addTyping).toBeDefined();
    expect(actions.deleteTyping).toBeDefined();
    expect(actions.setTyping).toBeDefined();
  });


  describe('#addTyping', () => {
    it('can successfully add typing indicator', () => {
      store.dispatch(actions.addTyping('userId'));
      expect(store.getActions()).toMatchSnapshot();
    });
  });


  describe('#deleteTyping', () => {
    it('can successfully delete typing indicator', () => {
      store.dispatch(actions.deleteTyping('userId'));
      expect(store.getActions()).toMatchSnapshot();
    });
  });


  describe('#setTyping', () => {
    it('can successfully setTyping with value', () => {
      store.dispatch(actions.setTyping('userId', 'someValue'));
      expect(store.getActions()).toMatchSnapshot();
    });

    it('can successfully setTyping without value', () => {
      store.dispatch(actions.setTyping('userId'));
      expect(store.getActions()).toMatchSnapshot();
    });
  });
});
